;; AquaX/theme.jl
;; v0.0 06Jan00 by Barthel aus Pennswald <ld_barthel@yahoo.com>

;; sawmill --batch compiler -f compile-batch theme.jl

(let*
  (
;; font
    (font "-*-helvetica-bold-r-normal-*-*-140-*-*-p-*-*")

;; images
    ;; 1x23
    (title-images (list (make-image "title-inactive.png")
			(make-image "title-active.png")))

    ;; 6x23
    (title_l-images (list (make-image "title_l-inactive.png")
			(make-image "title_l-active.png")))
    (title_r-images (list (make-image "title_r-inactive.png")
			(make-image "title_r-active.png")))

    ;; 19x23
    (iconify-images (list (make-image "button-inactive.png")
                          (make-image "iconify-active.png")
			  (make-image "iconify-highlight.png")
                          (make-image "iconify-highlight.png")))

    (maximize-images (list (make-image "button-inactive.png")
                          (make-image "maximize-active.png")
			  (make-image "maximize-highlight.png")
                          (make-image "maximize-highlight.png")))

    (close-images (list (make-image "button-inactive.png")
                          (make-image "close-active.png")
			  (make-image "close-highlight.png")
                          (make-image "close-highlight.png")))

    (one_window-images (list (make-image "button-inactive.png")
                          (make-image "one_window-focused-inactive.png")
			  (make-image "one_window-highlight.png")
                          (make-image "one_window-highlight.png")))

    ;; This type of bottom border does not appear in the MacOS X screenshots.
    ;; My first attempts at the drop-shadow effect failed, so I settled for
    ;; this kludge--but it's a kludge consistent with the rest of the theme!
    
    ;; 1x7
    (bottom-border-images (list (make-image "border_b-inactive.png")
    			  (make-image "border_b-active.png")))

    ;; 6x7
    (bottom-left-images (list (make-image "border_bl-inactive.png")
    			  (make-image "border_bl-active.png")))

    (bottom-right-images (list (make-image "border_br-inactive.png")
    			  (make-image "border_br-active.png")))


;; frame layout

    (frame
     `(

    ;; title
        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -23)
         (left-edge . 63)
         (right-edge . 25)
         (class . title)
        )

    ;; title corners
    	((background . ,title_l-images)
	 (top-edge . -23)
	 (left-edge . 0)
	 (class . top-left-corner)
	)

    	((background . ,title_r-images)
	 (top-edge . -23)
	 (right-edge . 0)
	 (class . top-right-corner)
	) 

    ;; close button
        ((background . ,close-images)
         (top-edge . -23)
         (left-edge . 6)
         (class . close-button)
        )
    
    ;; iconify button
        ((background . ,iconify-images)
         (top-edge . -23)
         (left-edge . 25)
         (class . iconify-button)
        )

    ;; maximize button
        ((background . ,maximize-images)
         (top-edge . -23)
         (left-edge . 44)
         (class . maximize-button)
        )

    ;; one_window button (we'll use this as our menu button)
        ((background . ,one_window-images)
         (top-edge . -23)
         (right-edge . 6)
         (class . menu-button)
        )

    ;; bottom border
        ((background . ,bottom-border-images)
         (bottom-edge . -7)
         (right-edge . 6)
         (left-edge . 6)
         (class . bottom-border)
        )

    ;; bottom corners
        ((background . ,bottom-left-images)
         (bottom-edge . -7)
         (left-edge . 0)
         (class . bottom-left-corner)
        )

        ((background . ,bottom-right-images)
         (bottom-edge . -7)
         (right-edge . 0)
         (class . bottom-right-corner)
        )
      )
    )

    (shaped-frame
     `(

    ;; title
        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -23)
         (left-edge . 63)
         (right-edge . 25)
         (class . title)
        )

    ;; title corners
    	((background . ,title_l-images)
	 (top-edge . -23)
	 (left-edge . 0)
	 (class . top-left-corner)
	)

    	((background . ,title_r-images)
	 (top-edge . -23)
	 (right-edge . 0)
	 (class . top-right-corner)
	) 

    ;; close button
        ((background . ,close-images)
         (top-edge . -23)
         (left-edge . 6)
         (class . close-button)
        )
    
    ;; iconify button
        ((background . ,iconify-images)
         (top-edge . -23)
         (left-edge . 25)
         (class . iconify-button)
        )

    ;; maximize button
        ((background . ,maximize-images)
         (top-edge . -23)
         (left-edge . 44)
         (class . maximize-button)
        )

    ;; one_window button (we'll use this as our menu button)
        ((background . ,one_window-images)
         (top-edge . -23)
         (right-edge . 6)
         (class . menu-button)
        )
      )
    )

    (transient-frame
     `(

    ;; title
        ((background . ,title-images)
         (foreground . ("black"))
         (font . ,font)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (top-edge . -23)
         (left-edge . 6)
         (right-edge . 6)
         (class . title)
        )

    ;; title corners
    	((background . ,title_l-images)
	 (top-edge . -23)
	 (left-edge . 0)
	 (class . top-left-corner)
	)

    	((background . ,title_r-images)
	 (top-edge . -23)
	 (right-edge . 0)
	 (class . top-right-corner)
	) 
      )
    )

  )
  
;; frame definition

  (add-frame-style 'AquaX
    (lambda (w type)
      (cond
            ((eq type 'shaped) shaped-frame)
            ((eq type 'shaped-transient) transient-frame)
            ((eq type 'transient) transient-frame)
            ((eq type 'unframed) nil-frame)
            (t frame)
      )
    )
  )

)
